Bug 1558970 - sudo on F28 Server Edition beta complains about missing libsss_sudo.so
Summary: sudo on F28 Server Edition beta complains about missing libsss_sudo.so
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: sssd
Version: 28
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Michal Zidek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard: AcceptedFreezeException
Depends On:
Blocks: F28BetaFreezeException
TreeView+ depends on / blocked
 
Reported: 2018-03-21 12:30 UTC by Stephen Gallagher
Modified: 2019-05-28 23:43 UTC (History)
18 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-05-28 23:43:13 UTC
Type: Bug
Embargoed:


Attachments (Terms of Use)

Description Stephen Gallagher 2018-03-21 12:30:10 UTC
Description of problem:
When attempting to use sudo on a freshly-installed F28 Server Edition Beta Candidate, it generates a noisy warning (but proceeds with the request based exclusively on local sudoers information).

Version-Release number of selected component (if applicable):
sssd-1.16.0-12.fc28.x86_64
sudo-1.8.22-0.2.b1.fc28.x86_64

How reproducible:
Every time

Steps to Reproduce:
1. Install Fedora Server from the DVD install media (or network install pointing at the Server variant) without checking the "install updates from the network" option or pointing the installer at the Everything repo.
2. Sign in to the local machine and run any sudo command.

Actual results:
```
sudo: unable to load /usr/lib64/libsss_sudo.so: /usr/lib64/libsss_sudo.so: cannot open shared object file: No such file or directory
sudo: unable to initialize SSS source. Is SSSD installed on your machine?
```
(Followed by executing based on local sudoers information).


Expected results:
No warning should be given on a default install.

Additional info:

There *might* be a slight security issue involved here; if the machine is enrolled with a FreeIPA domain with freeipa-client-install or via realmd, this does not cause the libsss_sudo package to be installed. So, even if the FreeIPA domain is providing sudo rules, the client will not be honoring them. If the sudo rules expressly disallow anything that the local rules would have otherwise allowed, there could be an unfortunate interaction.

I'm not making this security-private as it's a pre-release issue that will only affect new installations.

Comment 1 Fedora Blocker Bugs Application 2018-03-21 12:32:52 UTC
Proposed as a Freeze Exception for 28-beta by Fedora user sgallagh using the blocker tracking app because:

 While the warning generated by this bug is harmless on most systems[*], it is a bad user experience on a highly-visible tool of Fedora Server Edition and as such should probably be fixed before we ship Beta.

[*] There's an edge-case involving FreeIPA enrollment and sudo rules with negation, but not enough in my opinion to constitute a blocker.

Comment 2 Stephen Gallagher 2018-03-21 12:34:46 UTC
I can easily work around this issue by explicitly adding libsss_sudo to the Server DVD manifest, but I think there are other issues at play here as well. For example, I think it's definitely a bug that freeipa-server-install doesn't force libsss_sudo to be present.

Comment 3 Stephen Gallagher 2018-03-21 12:39:47 UTC
Oh, I forgot to explain the interaction that is causing this: when we generate the Server DVD, it is created without including things that are only "soft" dependencies (like libsss_sudo). Thus, if you install from that media, it won't install libsss_sudo. Then, sudo in its default configuration doesn't like this state, so it warns the user.

If the installation happened with the Everything repo enabled (such as clicking the "install updates from the network" button), then libsss_sudo would be available and pulled in.

I may split the freeipa-client-install bug into a separate issue, but I think there's definitely a bug in sudo; either it should have a strict dependency on libsss_client or it should not warn about it being missing. Or, I suppose, we should only warn if it *expects* to need libsss_sudo, such as if the machine is enrolled with a FreeIPA domain.

As I said, the easiest workaround for F28 Beta is to explicitly include this subpackage in the comps.xml definition for Server Edition, but the real fix should be in the packaging of these two projects.

Comment 4 Daniel Kopeček 2018-03-21 12:41:53 UTC
I don't think we can fix this from the sudo side. Please switch this to a more appropriate component (freeipa?) so that it gets noticed.

Comment 5 Daniel Kopeček 2018-03-21 12:44:37 UTC
btw sudo complains because there's "sudoers: sss ..." in /etc/nsswitch.conf.
Either remove that nss source or install the required dependencies.

Comment 6 Stephen Gallagher 2018-03-21 12:58:30 UTC
Workaround submitted as PR to fedora-comps: https://pagure.io/fedora-comps/pull-request/246

Comment 7 Stephen Gallagher 2018-03-21 13:12:51 UTC
Well, this is also fallout from the fact that sudo uses another package's config file. Whee.

I'll move this to sssd for the moment, but we'll have to figure out a better solution down the road. I wonder if we should perhaps move ownership and maintenance of nsswitch.conf to authselect, actually...

Comment 8 Jakub Hrozek 2018-03-21 13:14:30 UTC
(In reply to Stephen Gallagher from comment #7)

> I wonder if we should perhaps move ownership and
> maintenance of nsswitch.conf to authselect, actually...

I agreed with you in the authselect upstream repo :-) -- https://github.com/pbrezina/authselect/issues/9

Comment 9 Paul Whalen 2018-03-21 15:23:27 UTC
+1 FE

Comment 10 Adam Williamson 2018-03-21 15:38:16 UTC
Obvious +1 FE, sudo should certainly work out-of-the-box.

Comment 11 Ben Williams 2018-03-21 15:44:53 UTC
+1 FE

Comment 12 Adam Williamson 2018-03-21 15:58:31 UTC
OK, that's +3, setting accepted.

Comment 13 Ben Cotton 2019-05-02 19:51:40 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 14 Ben Cotton 2019-05-28 23:43:13 UTC
Fedora 28 changed to end-of-life (EOL) status on 2019-05-28. Fedora 28 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.